#ifndef TITLELESSWINDOW_H
#define TITLELESSWINDOW_H

#endif // TITLELESSWINDOW_H
#include <QQuickWindow>
#include <QFocusEvent>
#include <QDebug>
// kysdk
#include <kysdk/applications/windowmanager/windowmanager.h>
#include <kysdk/applications/ukuistylehelper/ukui-decoration-manager.h>
#include <ukuistylehelper/xatom-helper.h>

#include <QGuiApplication>

class TitleLessWindow : public QQuickWindow
{
    Q_OBJECT

public:
    TitleLessWindow(QWindow *parent = nullptr) : QQuickWindow(parent) {
        // 无边框窗口不需要去除标题栏
        if (this->flags().testFlag(Qt::FramelessWindowHint)) {
            return;
        }

        if (QGuiApplication::platformName().startsWith(QStringLiteral("wayland"))) {
            UKUIDecorationManager::getInstance()->removeHeaderBar(this);
        } else {
            MotifWmHints hints;
            hints.flags = MWM_HINTS_FUNCTIONS | MWM_HINTS_DECORATIONS;
            hints.functions = MWM_FUNC_ALL;
            hints.decorations = MWM_DECOR_BORDER;
            XAtomHelper::getInstance()->setWindowMotifHint(static_cast<int>(this->winId()), hints);
        }
    }

protected:
    void focusOutEvent(QFocusEvent *event) override {
        qDebug() << "Window lost focus!";
        // 在这里发出一个信号到 QML
        emit windowDeactivated();
        QQuickWindow::focusOutEvent(event);
    }

signals:
    void windowDeactivated();
};
